#include<evive.h>

#define trig1 2
#define echo1 3
#define trig2 4
#define echo2 5
#define servo_pin 44
#define lid_close 0
#define lid_open 80
#define buzz 46

#define ultrasonic_1_threshould 15
#define ultrasonic_2_threshould 3

long duration1;
long duration2;
int distance1;
int distance2;
int temp;
unsigned int counter=0;
unsigned int counter2 =0;

Servo myServo;


void setup() {
  // put your setup code here, to run once:
  Serial.begin(9600);

  myServo.attach(44);

  pinMode(trig1,OUTPUT);
  pinMode(trig2,OUTPUT);
  pinMode(echo1,INPUT);
  pinMode(echo2,INPUT);

  tft_init(INITR_GREENTAB);
   tft.setRotation(1);
   tft.fillScreen(1);

    tft.setCursor(25,10);
  tft.setTextSize(2);
  tft.setTextColor(ST7735_WHITE,ST7735_BLACK);
  tft.print("STEMpedia");

   tft.setCursor(35,40);
  tft.setTextSize(1.8);
  tft.setTextColor(ST7735_GREEN,ST7735_BLACK);
  tft.print("SMART DUSTBIN ");

  tft.setCursor(30,60);
  tft.setTextSize(1.8);
  tft.setTextColor(ST7735_GREEN,ST7735_BLACK);
  tft.print("DUSTBIN STATUS");

 
  tft.setTextColor(ST7735_GREEN,ST7735_BLACK);
  tft.setCursor(0,105);
  tft.setTextSize(1.8);
  tft.print("FOR MORE INFORMATION VISIT");
  tft.setCursor(30,115);
  tft.setTextColor(ST7735_WHITE,ST7735_BLACK);
  tft.print("thestempedia.com");

}

void loop() {
  // put your main code here, to run repeatedly:
  distance1 = calculateDistance1();
  distance2 = calculateDistance2();
  Serial.print("distance1=");
  Serial.println(distance1);
  Serial.print("distance2=");
  Serial.println(distance2);
  Serial.println("---------------------------------------");
  

  if(distance1<= ultrasonic_1_threshould)
  {
    counter2++;
    if(counter2>3)
    {
        myServo.write(lid_open);
        counter2=0;
        delay(3000);
        
    }
  
  }
  else
  {
    distance2 = constrain(distance2,0,19);
     temp = map(distance2,0,19,100,0);
      tft.setCursor(50,70);
      tft.setTextSize(1.8);
      tft.setTextColor(ST7735_WHITE,ST7735_BLACK);
      tft.print(temp);
      tft.print("  ");
      tft.setCursor(65,70);
      tft.print("% FULL");
 
      myServo.write(lid_close);
  }
  if(distance2<=ultrasonic_2_threshould)
  {
    counter++;
    if(counter>8)
    {
      while(distance2<=ultrasonic_2_threshould)
      {
        distance2 = calculateDistance2();
        counter=0;
        siren();
       
      }
    }
  }
//  else
//  {
//      distance2 = map(distance2,0,19,100,0);
//      tft.setCursor(50,70);
//      tft.setTextSize(1.8);
//      tft.setTextColor(ST7735_WHITE,ST7735_BLACK);
//      tft.print(distance2);
//      tft.print("  ");
//      tft.setCursor(65,70);
//      tft.print("% FULL");
// 
//      myServo.write(lid_close);
//
//  }
  

}

int calculateDistance1()
     { 
  
          digitalWrite(trig1, LOW); 
          delayMicroseconds(2);
          // Sets the trigPin on HIGH state for 10 micro seconds
          digitalWrite(trig1, HIGH); 
          delayMicroseconds(10);
          digitalWrite(trig1, LOW);
          duration1 = pulseIn(echo1, HIGH); // Reads the echoPin, returns the sound wave travel time in microseconds
          distance1= duration1*0.034/2;
          return distance1;
     }

     int calculateDistance2()
     { 
  
          digitalWrite(trig2, LOW); 
          delayMicroseconds(2);
          // Sets the trigPin on HIGH state for 10 micro seconds
          digitalWrite(trig2, HIGH); 
          delayMicroseconds(10);
          digitalWrite(trig2, LOW);
          duration2 = pulseIn(echo2, HIGH); // Reads the echoPin, returns the sound wave travel time in microseconds
          distance2= duration2*0.034/2;
          return distance2;
     }

     void siren()
  {
     for(int hz = 440; hz < 1000; hz+=25)
         {
           tone(buzz, hz, 50);
           delay(5);
           
         }
     // Whoop down
    for(int hz = 1000; hz > 440; hz-=25)
        {
           tone(buzz, hz, 50);
           delay(5);      
        }
  }
